Index: uspace/lib/ui/test/slider.c
===================================================================
--- uspace/lib/ui/test/slider.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/test/slider.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,531 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/context.h>
+#include <gfx/coord.h>
+#include <mem.h>
+#include <pcut/pcut.h>
+#include <stdbool.h>
+#include <ui/control.h>
+#include <ui/slider.h>
+#include <ui/resource.h>
+#include "../private/slider.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(slider);
+
+static errno_t testgc_set_clip_rect(void *, gfx_rect_t *);
+static errno_t testgc_set_color(void *, gfx_color_t *);
+static errno_t testgc_fill_rect(void *, gfx_rect_t *);
+static errno_t testgc_update(void *);
+static errno_t testgc_bitmap_create(void *, gfx_bitmap_params_t *,
+    gfx_bitmap_alloc_t *, void **);
+static errno_t testgc_bitmap_destroy(void *);
+static errno_t testgc_bitmap_render(void *, gfx_rect_t *, gfx_coord2_t *);
+static errno_t testgc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
+
+static gfx_context_ops_t ops = {
+	.set_clip_rect = testgc_set_clip_rect,
+	.set_color = testgc_set_color,
+	.fill_rect = testgc_fill_rect,
+	.update = testgc_update,
+	.bitmap_create = testgc_bitmap_create,
+	.bitmap_destroy = testgc_bitmap_destroy,
+	.bitmap_render = testgc_bitmap_render,
+	.bitmap_get_alloc = testgc_bitmap_get_alloc
+};
+
+static void test_slider_moved(ui_slider_t *, void *, gfx_coord_t);
+
+static ui_slider_cb_t test_slider_cb = {
+	.moved = test_slider_moved
+};
+
+static ui_slider_cb_t dummy_slider_cb = {
+};
+
+typedef struct {
+	bool bm_created;
+	bool bm_destroyed;
+	gfx_bitmap_params_t bm_params;
+	void *bm_pixels;
+	gfx_rect_t bm_srect;
+	gfx_coord2_t bm_offs;
+	bool bm_rendered;
+	bool bm_got_alloc;
+} test_gc_t;
+
+typedef struct {
+	test_gc_t *tgc;
+	gfx_bitmap_alloc_t alloc;
+	bool myalloc;
+} testgc_bitmap_t;
+
+typedef struct {
+	bool moved;
+	gfx_coord_t pos;
+} test_cb_resp_t;
+
+/** Create and destroy slider */
+PCUT_TEST(create_destroy)
+{
+	ui_slider_t *slider = NULL;
+	errno_t rc;
+
+	rc = ui_slider_create(NULL, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(slider);
+
+	ui_slider_destroy(slider);
+}
+
+/** ui_slider_destroy() can take NULL argument (no-op) */
+PCUT_TEST(destroy_null)
+{
+	ui_slider_destroy(NULL);
+}
+
+/** ui_slider_ctl() returns control that has a working virtual destructor */
+PCUT_TEST(ctl)
+{
+	ui_slider_t *slider;
+	ui_control_t *control;
+	errno_t rc;
+
+	rc = ui_slider_create(NULL, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	control = ui_slider_ctl(slider);
+	PCUT_ASSERT_NOT_NULL(control);
+
+	ui_control_destroy(control);
+}
+
+/** Set slider rectangle sets internal field */
+PCUT_TEST(set_rect)
+{
+	ui_slider_t *slider;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = ui_slider_create(NULL, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	ui_slider_set_rect(slider, &rect);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.x, slider->rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.y, slider->rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.x, slider->rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.y, slider->rect.p1.y);
+
+	ui_slider_destroy(slider);
+}
+
+/** Paint slider */
+PCUT_TEST(paint)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_slider_t *slider;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_slider_create(resource, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_slider_paint(slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_slider_destroy(slider);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Test ui_slider_moved() */
+PCUT_TEST(moved)
+{
+	errno_t rc;
+	ui_slider_t *slider;
+	test_cb_resp_t resp;
+
+	rc = ui_slider_create(NULL, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Moved with no callbacks set */
+	ui_slider_moved(slider, 42);
+
+	/* Moved with callback not implementing clicked */
+	ui_slider_set_cb(slider, &dummy_slider_cb, NULL);
+	ui_slider_moved(slider, 42);
+
+	/* Moved with real callback set */
+	resp.moved = false;
+	resp.pos = 0;
+	ui_slider_set_cb(slider, &test_slider_cb, &resp);
+	ui_slider_moved(slider, 42);
+	PCUT_ASSERT_TRUE(resp.moved);
+	PCUT_ASSERT_INT_EQUALS(42, resp.pos);
+
+	ui_slider_destroy(slider);
+}
+
+/** Press and release slider */
+PCUT_TEST(press_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_coord2_t pos;
+	gfx_rect_t rect;
+	ui_slider_t *slider;
+	test_cb_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_slider_create(resource, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 110;
+	rect.p1.y = 120;
+	ui_slider_set_rect(slider, &rect);
+
+	resp.moved = false;
+	ui_slider_set_cb(slider, &test_slider_cb, &resp);
+
+	PCUT_ASSERT_FALSE(slider->held);
+
+	pos.x = 11;
+	pos.y = 22;
+
+	ui_slider_press(slider, &pos);
+	PCUT_ASSERT_TRUE(slider->held);
+	PCUT_ASSERT_FALSE(resp.moved);
+
+	pos.x = 21;
+	pos.y = 32;
+
+	ui_slider_release(slider, &pos);
+	PCUT_ASSERT_FALSE(slider->held);
+	PCUT_ASSERT_TRUE(resp.moved);
+	PCUT_ASSERT_INT_EQUALS(10, slider->pos);
+
+	ui_slider_destroy(slider);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Press, update and release slider */
+PCUT_TEST(press_uodate_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	gfx_coord2_t pos;
+	gfx_rect_t rect;
+	ui_slider_t *slider;
+	test_cb_resp_t resp;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_slider_create(resource, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 110;
+	rect.p1.y = 120;
+	ui_slider_set_rect(slider, &rect);
+
+	resp.moved = false;
+	ui_slider_set_cb(slider, &test_slider_cb, &resp);
+
+	PCUT_ASSERT_FALSE(slider->held);
+
+	pos.x = 11;
+	pos.y = 22;
+
+	ui_slider_press(slider, &pos);
+	PCUT_ASSERT_TRUE(slider->held);
+	PCUT_ASSERT_FALSE(resp.moved);
+
+	pos.x = 21;
+	pos.y = 32;
+
+	ui_slider_update(slider, &pos);
+	PCUT_ASSERT_TRUE(slider->held);
+	PCUT_ASSERT_TRUE(resp.moved);
+	PCUT_ASSERT_INT_EQUALS(10, slider->pos);
+
+	pos.x = 31;
+	pos.y = 42;
+
+	ui_slider_release(slider, &pos);
+	PCUT_ASSERT_FALSE(slider->held);
+	PCUT_ASSERT_TRUE(resp.moved);
+	PCUT_ASSERT_INT_EQUALS(20, slider->pos);
+
+	ui_slider_destroy(slider);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_pos_event() correctly translates POS_PRESS/POS_RELEASE */
+PCUT_TEST(pos_event_press_release)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_slider_t *slider;
+	ui_evclaim_t claim;
+	pos_event_t event;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_slider_create(resource, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(slider->held);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 30;
+	rect.p1.y = 40;
+	ui_slider_set_rect(slider, &rect);
+
+	/* Press outside is not claimed and does nothing */
+	event.type = POS_PRESS;
+	event.hpos = 1;
+	event.vpos = 2;
+	claim = ui_slider_pos_event(slider, &event);
+	PCUT_ASSERT_FALSE(slider->held);
+	PCUT_ASSERT_EQUALS(ui_unclaimed, claim);
+
+	/* Press inside is claimed and depresses slider */
+	event.type = POS_PRESS;
+	event.hpos = 11;
+	event.vpos = 22;
+	claim = ui_slider_pos_event(slider, &event);
+	PCUT_ASSERT_TRUE(slider->held);
+	PCUT_ASSERT_EQUALS(ui_claimed, claim);
+
+	/* Release outside (or anywhere) is claimed and relases slider */
+	event.type = POS_RELEASE;
+	event.hpos = 41;
+	event.vpos = 32;
+	claim = ui_slider_pos_event(slider, &event);
+	PCUT_ASSERT_FALSE(slider->held);
+	PCUT_ASSERT_EQUALS(ui_claimed, claim);
+
+	ui_slider_destroy(slider);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** ui_slider_length() correctly determines slider length */
+PCUT_TEST(length)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
+	ui_slider_t *slider;
+	gfx_coord_t length;
+	gfx_rect_t rect;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_slider_create(resource, "Hello", &slider);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(slider->held);
+
+	rect.p0.x = 10;
+	rect.p0.y = 20;
+	rect.p1.x = 110;
+	rect.p1.y = 120;
+	ui_slider_set_rect(slider, &rect);
+
+	length = ui_slider_length(slider);
+	PCUT_ASSERT_INT_EQUALS(110 - 10 - 15, length);
+
+	ui_slider_destroy(slider);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+static errno_t testgc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_set_color(void *arg, gfx_color_t *color)
+{
+	(void) arg;
+	(void) color;
+	return EOK;
+}
+
+static errno_t testgc_fill_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_update(void *arg)
+{
+	(void) arg;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_create(void *arg, gfx_bitmap_params_t *params,
+    gfx_bitmap_alloc_t *alloc, void **rbm)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+	testgc_bitmap_t *tbm;
+
+	tbm = calloc(1, sizeof(testgc_bitmap_t));
+	if (tbm == NULL)
+		return ENOMEM;
+
+	if (alloc == NULL) {
+		tbm->alloc.pitch = (params->rect.p1.x - params->rect.p0.x) *
+		    sizeof(uint32_t);
+		tbm->alloc.off0 = 0;
+		tbm->alloc.pixels = calloc(sizeof(uint32_t),
+		    (params->rect.p1.x - params->rect.p0.x) *
+		    (params->rect.p1.y - params->rect.p0.y));
+		tbm->myalloc = true;
+		if (tbm->alloc.pixels == NULL) {
+			free(tbm);
+			return ENOMEM;
+		}
+	} else {
+		tbm->alloc = *alloc;
+	}
+
+	tbm->tgc = tgc;
+	tgc->bm_created = true;
+	tgc->bm_params = *params;
+	tgc->bm_pixels = tbm->alloc.pixels;
+	*rbm = (void *)tbm;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_destroy(void *bm)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	if (tbm->myalloc)
+		free(tbm->alloc.pixels);
+	tbm->tgc->bm_destroyed = true;
+	free(tbm);
+	return EOK;
+}
+
+static errno_t testgc_bitmap_render(void *bm, gfx_rect_t *srect,
+    gfx_coord2_t *offs)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	tbm->tgc->bm_rendered = true;
+	tbm->tgc->bm_srect = *srect;
+	tbm->tgc->bm_offs = *offs;
+	return EOK;
+}
+
+static errno_t testgc_bitmap_get_alloc(void *bm, gfx_bitmap_alloc_t *alloc)
+{
+	testgc_bitmap_t *tbm = (testgc_bitmap_t *)bm;
+	*alloc = tbm->alloc;
+	tbm->tgc->bm_got_alloc = true;
+	return EOK;
+}
+
+static void test_slider_moved(ui_slider_t *slider, void *arg, gfx_coord_t pos)
+{
+	test_cb_resp_t *resp = (test_cb_resp_t *) arg;
+
+	resp->moved = true;
+	resp->pos = pos;
+}
+
+PCUT_EXPORT(slider);
Index: uspace/lib/ui/test/ui.c
===================================================================
--- uspace/lib/ui/test/ui.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/test/ui.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -35,6 +35,6 @@
 PCUT_TEST_SUITE(ui);
 
-/** Create and destroy UI */
-PCUT_TEST(create_destroy)
+/** Create and destroy UI with display */
+PCUT_TEST(create_disp_destroy)
 {
 	ui_t *ui = NULL;
@@ -49,4 +49,18 @@
 }
 
+/** Create and destroy UI with console */
+PCUT_TEST(create_cons_destroy)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_cons(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+	PCUT_ASSERT_NULL(ui->console);
+
+	ui_destroy(ui);
+}
+
 /** ui_destroy() can take NULL argument (no-op) */
 PCUT_TEST(destroy_null)
@@ -55,3 +69,85 @@
 }
 
+/** ui_run() / ui_quit() */
+PCUT_TEST(run_quit)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	/* Set exit flag */
+	ui_quit(ui);
+
+	/* ui_run() should return immediately */
+	ui_run(ui);
+
+	ui_destroy(ui);
+}
+
+/** ui_paint() */
+PCUT_TEST(paint)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_cons(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	/* In absence of windows ui_paint() should just return EOK */
+	rc = ui_paint(ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_destroy(ui);
+}
+
+/** ui_is_textmode() */
+PCUT_TEST(is_textmode)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp((display_t *)(-1), &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	PCUT_ASSERT_FALSE(ui_is_textmode(ui));
+
+	ui_destroy(ui);
+
+	rc = ui_create_cons((console_ctrl_t *)(-1), &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	PCUT_ASSERT_TRUE(ui_is_textmode(ui));
+
+	ui_destroy(ui);
+}
+
+/** ui_is_fullscreen() */
+PCUT_TEST(is_fullscreen)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp((display_t *)(-1), &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	PCUT_ASSERT_FALSE(ui_is_fullscreen(ui));
+
+	ui_destroy(ui);
+
+	rc = ui_create_cons((console_ctrl_t *)(-1), &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	PCUT_ASSERT_TRUE(ui_is_fullscreen(ui));
+
+	ui_destroy(ui);
+}
+
 PCUT_EXPORT(ui);
Index: uspace/lib/ui/test/wdecor.c
===================================================================
--- uspace/lib/ui/test/wdecor.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/test/wdecor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,6 +41,8 @@
 PCUT_TEST_SUITE(wdecor);
 
+static errno_t testgc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t testgc_set_color(void *, gfx_color_t *);
 static errno_t testgc_fill_rect(void *, gfx_rect_t *);
+static errno_t testgc_update(void *);
 static errno_t testgc_bitmap_create(void *, gfx_bitmap_params_t *,
     gfx_bitmap_alloc_t *, void **);
@@ -50,6 +52,8 @@
 
 static gfx_context_ops_t ops = {
+	.set_clip_rect = testgc_set_clip_rect,
 	.set_color = testgc_set_color,
 	.fill_rect = testgc_fill_rect,
+	.update = testgc_update,
 	.bitmap_create = testgc_bitmap_create,
 	.bitmap_destroy = testgc_bitmap_destroy,
@@ -177,5 +181,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_resource_create(gc, &resource);
+	rc = ui_resource_create(gc, false, &resource);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_NOT_NULL(resource);
@@ -354,11 +358,22 @@
 PCUT_TEST(pos_event_move)
 {
-	ui_wdecor_t *wdecor;
+	errno_t rc;
 	gfx_rect_t rect;
 	pos_event_t event;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
 	test_cb_resp_t resp;
-	errno_t rc;
-
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_decorated, &wdecor);
+	ui_resource_t *resource = NULL;
+	ui_wdecor_t *wdecor;
+
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -386,4 +401,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -391,4 +410,7 @@
 PCUT_TEST(get_geom_none)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -396,5 +418,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_none, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_none, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -428,4 +458,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -433,4 +467,7 @@
 PCUT_TEST(get_geom_frame)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -438,5 +475,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_frame, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_frame, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -470,4 +515,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -475,4 +524,7 @@
 PCUT_TEST(get_geom_frame_titlebar)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -480,5 +532,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_frame | ui_wds_titlebar,
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_frame | ui_wds_titlebar,
 	    &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
@@ -513,4 +573,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -518,4 +582,7 @@
 PCUT_TEST(get_geom_decorated)
 {
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+	ui_resource_t *resource = NULL;
 	ui_wdecor_t *wdecor;
 	gfx_rect_t rect;
@@ -523,5 +590,13 @@
 	errno_t rc;
 
-	rc = ui_wdecor_create(NULL, "Hello", ui_wds_decorated, &wdecor);
+	memset(&tgc, 0, sizeof(tgc));
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_resource_create(gc, false, &resource);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(resource);
+
+	rc = ui_wdecor_create(resource, "Hello", ui_wds_decorated, &wdecor);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -555,4 +630,8 @@
 
 	ui_wdecor_destroy(wdecor);
+	ui_resource_destroy(resource);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 }
 
@@ -768,4 +847,11 @@
 }
 
+static errno_t testgc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	(void) arg;
+	(void) rect;
+	return EOK;
+}
+
 static errno_t testgc_set_color(void *arg, gfx_color_t *color)
 {
@@ -779,4 +865,10 @@
 	(void) arg;
 	(void) rect;
+	return EOK;
+}
+
+static errno_t testgc_update(void *arg)
+{
+	(void) arg;
 	return EOK;
 }
Index: uspace/lib/ui/test/window.c
===================================================================
--- uspace/lib/ui/test/window.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/test/window.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,8 +66,10 @@
 static errno_t test_ctl_paint(void *);
 static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
+static void test_ctl_unfocus(void *);
 
 static ui_control_ops_t test_ctl_ops = {
 	.paint = test_ctl_paint,
-	.pos_event = test_ctl_pos_event
+	.pos_event = test_ctl_pos_event,
+	.unfocus = test_ctl_unfocus
 };
 
@@ -90,4 +92,5 @@
 	bool pos;
 	pos_event_t pos_event;
+	bool unfocus;
 } test_ctl_resp_t;
 
@@ -175,4 +178,50 @@
 }
 
+/** ui_window_get_active */
+PCUT_TEST(get_active)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window1 = NULL;
+	ui_window_t *window2 = NULL;
+	ui_window_t *awnd;
+
+	rc = ui_create_cons(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	awnd = ui_window_get_active(ui);
+	PCUT_ASSERT_NULL(awnd);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window1);
+
+	awnd = ui_window_get_active(ui);
+	PCUT_ASSERT_EQUALS(window1, awnd);
+
+	rc = ui_window_create(ui, &params, &window2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window2);
+
+	awnd = ui_window_get_active(ui);
+	PCUT_ASSERT_EQUALS(window2, awnd);
+
+	ui_window_destroy(window2);
+
+	awnd = ui_window_get_active(ui);
+	PCUT_ASSERT_EQUALS(window1, awnd);
+
+	ui_window_destroy(window1);
+
+	awnd = ui_window_get_active(ui);
+	PCUT_ASSERT_NULL(awnd);
+
+	ui_destroy(ui);
+}
+
 /** ui_window_resize */
 PCUT_TEST(resize)
@@ -242,4 +291,28 @@
 }
 
+/** ui_window_set_ctl_cursor() */
+PCUT_TEST(set_ctl_cursor)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(window);
+
+	ui_window_set_ctl_cursor(window, ui_curs_ibeam);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
 /** ui_window_get_app_gc() return valid GC */
 PCUT_TEST(get_app_gc)
@@ -258,6 +331,6 @@
 	params.rect.p0.x = 0;
 	params.rect.p0.y = 0;
-	params.rect.p0.x = 10;
-	params.rect.p0.y = 10;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
 
 	rc = ui_window_create(ui, &params, &window);
@@ -388,4 +461,40 @@
 	PCUT_ASSERT_INT_EQUALS(event.hpos, resp.pos_event.hpos);
 	PCUT_ASSERT_INT_EQUALS(event.vpos, resp.pos_event.vpos);
+
+	/* Need to remove first because we didn't implement the destructor */
+	ui_window_remove(window, control);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** ui_window_def_unfocus() delivers unfocus event to control in window */
+PCUT_TEST(def_unfocus)
+{
+	errno_t rc;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	ui_control_t *control = NULL;
+	test_ctl_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Hello";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = ui_control_new(&test_ctl_ops, &resp, &control);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_window_add(window, control);
+
+	resp.unfocus = false;
+
+	ui_window_def_unfocus(window);
+	PCUT_ASSERT_TRUE(resp.unfocus);
 
 	/* Need to remove first because we didn't implement the destructor */
@@ -701,3 +810,10 @@
 }
 
+static void test_ctl_unfocus(void *arg)
+{
+	test_ctl_resp_t *resp = (test_ctl_resp_t *) arg;
+
+	resp->unfocus = true;
+}
+
 PCUT_EXPORT(window);
Index: uspace/lib/usbhid/include/usb/hid/hidtypes.h
===================================================================
--- uspace/lib/usbhid/include/usb/hid/hidtypes.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/usbhid/include/usb/hid/hidtypes.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -211,5 +211,5 @@
 	int usages_count;
 
-	/** Usage page*/
+	/** Usage page */
 	uint32_t usage_page;
 
@@ -226,8 +226,8 @@
 	int32_t logical_maximum;
 
-	/** Length of the items in bits*/
+	/** Length of the items in bits */
 	int32_t size;
 
-	/** COunt of items*/
+	/** Count of items */
 	int32_t count;
 
@@ -252,11 +252,11 @@
 	uint32_t designator_index;
 
-	/** Minimum valid designator value*/
+	/** Minimum valid designator value */
 	uint32_t designator_minimum;
 
-	/** Maximum valid designator value*/
+	/** Maximum valid designator value */
 	uint32_t designator_maximum;
 
-	/** Minimal valid physical value*/
+	/** Minimal valid physical value */
 	int32_t physical_minimum;
 
@@ -264,5 +264,5 @@
 	int32_t physical_maximum;
 
-	/** Items attributes*/
+	/** Items attributes */
 	uint8_t item_flags;
 
@@ -270,8 +270,8 @@
 	usb_hid_report_type_t type;
 
-	/** current collection path*/
+	/** current collection path */
 	usb_hid_report_path_t *usage_path;
 
-	/** Unused*/
+	/** Unused */
 	link_t link;
 
Index: uspace/srv/audio/hound/hound_ctx.c
===================================================================
--- uspace/srv/audio/hound/hound_ctx.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/audio/hound/hound_ctx.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -403,5 +403,5 @@
 		return ENOMEM;
 	}
-	log_verbose("CTX: %p: Mixing %lu streams", ctx,
+	log_verbose("CTX: %p: Mixing %zu streams", ctx,
 	    list_count(&ctx->streams));
 	pcm_format_silence(buffer, size, &source->format);
@@ -413,5 +413,5 @@
 			log_warning("Not enough data in stream buffer");
 	}
-	log_verbose("CTX: %p. Pushing audio to %lu connections", ctx,
+	log_verbose("CTX: %p. Pushing audio to %zu connections", ctx,
 	    list_count(&source->connections));
 	list_foreach(source->connections, source_link, connection_t, conn) {
Index: uspace/srv/bd/file_bd/meson.build
===================================================================
--- uspace/srv/bd/file_bd/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/bd/file_bd/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'device' ]
 src = files('file_bd.c')
Index: uspace/srv/bd/rd/meson.build
===================================================================
--- uspace/srv/bd/rd/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/bd/rd/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'device' ]
 src = files('rd.c')
Index: uspace/srv/devman/meson.build
===================================================================
--- uspace/srv/devman/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/devman/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'device' ]
 src = files(
 	'client_conn.c',
